<template>
<div class="outputs q-pa-md">
  <div class="outputs__dynamic-header q-mb-lg">
    <slot name="dynamic_header" />
  </div>

  <div class="outputs__content-part full-width q-mb-lg">
    <div v-if="isColorMapNeeded && !isColorMapDataEmpty" class="outputs__content-part__color-map-container full-width">
      <ColorMapComponent
        :indicator="props.indicator"
        :data="colorMapData"
      />
    </div>

    <div v-if="isChartDataEmpty" class="outputs__content-part__chart-container full-width q-pa-md">
      <q-card>
        <q-card-section class="text-center text-h6 text-negative q-py-lg">
          No hay información que coincida con los parámetros de búsqueda seleccionados
        </q-card-section>
    </q-card>
    </div>

    <div v-if="!isChartDataEmpty" class="outputs__content-part__chart-container full-width q-pa-md">
      <HorizontalBarChartComponent
        v-if="isHorizontalBarChartNeeded"
        :indicator="props.indicator"
        :data="chartData"
      />

      <VerticalBarChartComponent
        v-if="isVerticalBarChartNeeded"
        :indicator="props.indicator"
        :data="chartData"
      />

      <LineChartComponent
        v-if="isLineChartNeeded"
        :indicator="props.indicator"
        :data="chartData"
        :parentSize="resize"
      />

      <BoxPlotChartComponent
        v-if="isBoxPlotChartNeeded"
        :indicator="props.indicator"
        :data="chartData"
        :parentSize="resize"
      />

      <div class="box-plot-explanation q-mt-lg" v-if="isBoxPlotChartNeeded">
        <q-expansion-item
          v-model="isBoxPlotInterpretationExpanded"
          dense
          :caption="`${!isBoxPlotInterpretationExpanded ? 'Mostrar' : 'Ocultar'} interpretación de un diagrama de caja y bigotes`"
        >
          <q-card class="box-plot-explanation__content-card">
            <q-card-section>
              <div class="box-plot-explanation__content-card__title-part">
                <div class="box-plot-explanation__content-card__title-part__title">Interpretación de un diagrama de caja y bigotes</div>
                <div class="box-plot-explanation__content-card__title-part__subtitle">
                  <span>
                    Un diagrama de caja (Boxplot) es una forma estandarizada de mostrar la distribución de los datos basada en un resumen de cinco números: mínimo, primer cuartil [Q1], mediana, tercer cuartil [Q3] y máximo.
                  </span>
                </div>
              </div>
              <q-separator spaced/>

              <div class="box-plot-explanation__content-card__grafic-part">
                <div class="box-plot-explanation__content-card__grafic-part__picture">
                  <img src="../../../assets/explanations/box-plot-explanation.svg" alt="" />
                </div>
                <div class="box-plot-explanation__content-card__grafic-part__picture-explanation">
                  <ul>
                    <li><i>La línea central de la caja <b>(c)</b> indica la mediana de los datos.</i> Una mitad de los datos está por debajo de este valor, y la otra por encima. Si los datos son simétricos, la mediana estará en el centro de la caja. Si los datos están sesgados, la mediana estará más cerca de la parte superior o inferior de la caja.</li>
                    <li><i>Los extremos de arriba y abajo de la caja <b>(b), (d)</b> indican los cuartiles 25 y 75 que separan los datos en cuartos (25%).</i> La longitud de la caja es la diferencia entre estos dos cuartiles y se conoce como rango intercuartílico (IQR).</li>
                    <li><i>Las líneas que se extienden desde la caja <b>(a), (e)</b> se llaman bigotes.</i> Los bigotes representan la varianza esperada de los datos. Estos bigotes se extienden 1,5 veces el IQR desde los extremos superior e inferior de la caja. Si los datos no llegan hasta el final de los bigotes, estos se ajustan a los valores mínimo y máximo de los datos.</li>
                    <li><i>Si hay datos que queden por encima o por debajo de los extremos de los bigotes, se los representa con puntos <b>(f)</b>.</i> Estos puntos se conocen como valores atípicos. Un valor atípico es el que supera la varianza esperada. Merece la pena revisar estos puntos de datos para aclarar si son atípicos o erróneos. Los bigotes no incluyen dichos valores.</li>
                  </ul>
                </div>
              </div>
            </q-card-section>
          </q-card>
        </q-expansion-item>
      </div>

    <q-resize-observer debounce="1" @resize="onResize" />
    </div>
  </div>

  <div class="outputs__footer">
    <div class="outputs__footer__info-source column">
      <span>
        Fuente: Contrataciones Abiertas Ecuador
      </span>
      <span>
        Fecha de Consulta: {{ props.currentDate }}
      </span>
    </div>

    <q-separator vertical/>

    <div class="outputs__footer__download-buttons">
      <slot name="download_buttons"/>
    </div>

  </div>

</div>
</template>

<script setup>
import { computed, ref } from 'vue';
import ColorMapComponent from './color-map-component/ColorMapComponent.vue';
import HorizontalBarChartComponent from './horizontal-bar-chart-component/HorizontalBarChartComponent.vue';
import VerticalBarChartComponent from './vertical-bar-chart-component/VerticalBarChartComponent.vue';
import BoxPlotChartComponent from './box-plot-chart-component/BoxPlotChartComponent.vue';
import LineChartComponent from './line-chart-component/LineChartComponent.vue';

const props = defineProps({
  indicator:    { type: String, required: true },
  data:         { type: Object, required: true },
  currentDate:  { type: String, required: true },
});

const colorMapData = computed({
  get: () => props?.data?.colorMapData,
});

const chartData = computed({
  get: () => props?.data?.chartData,
});

const isColorMapNeeded = computed(() => props.indicator !== 'indicator_16' && props.indicator !== 'indicator_17');
const isHorizontalBarChartNeeded = computed(() => ['indicator_5_6', 'indicator_7_8', 'indicator_12', 'indicator_13'].includes(props.indicator));
const isVerticalBarChartNeeded = computed(() => ['indicator_1_2', 'indicator_3_4'].includes(props.indicator));
const isBoxPlotChartNeeded = computed(() => props.indicator === 'indicator_16' || props.indicator === 'indicator_17');
const isLineChartNeeded = computed(() => ['indicator_9', 'indicator_10_11', 'indicator_14', 'indicator_15'].includes(props.indicator));

const isChartDataEmpty = computed(() => chartData.value.length === 0);
const isColorMapDataEmpty = computed(() => colorMapData.value.length === 0);

const resize = ref(0);

const onResize = function (size) {
  resize.value = size.width;
};

const isBoxPlotInterpretationExpanded = ref(false);

</script>

<style lang="scss">
@use './outputs-component-stylesheet.scss';
</style>